
public class Reader extends Thread {
     private ReadWriteLock lock;
     private String id;

     Reader(ReadWriteLock lock, String id) {
	this.lock = lock;
	this.id = id;
     }

     @Override
     public void run() {
	 try {
	      while (true) {
               	Thread.sleep(700); //Zur Demo des Progress-Problems dieses sleep entfernen
		this.lock.acquireRead(id);
	       	System.out.println("READER "+id+"  examines");
          	Thread.sleep(500);
		this.lock.releaseRead(id);
	      }
          }
	 catch (InterruptedException e) {
	 }
    }
}