
public class Writer extends Thread {
     private ReadWriteLock lock;
     private String id;

     Writer(ReadWriteLock lock, String id) {
         this.lock = lock;
         this.id = id;
     }

     @Override
     public void run() {
	 try {
	     while (true) {
            	Thread.sleep(700); //Zur Demo des Progress-Problems dieses sleep entfernen
            	this.lock.request(id);
		this.lock.acquireWrite(id);
		System.out.println("WRITER "+id+ " modifies");
            	Thread.sleep(500);
     		this.lock.releaseWrite(id);
	      }
	    }
	 catch (InterruptedException e) {
	 }
     }
}
